
#include "descriptor/descriptor.h"

int main(void) {

  ITEM	pupilla,bianco,def;/*Attributi colore*/
  /*Oggetti della testa*/
  ITEM	pupilla_dx,pupilla_sx,testa,corna,muso,occhio_sx,occhio_dx,parte_alta,attacco_corna;
  ITEM	orecchio_sx,orecchio_dx,orecchio_sx_interno,orecchio_dx_interno;
  ITEM	scene;

  set_background(0.074218,0.6992,0.84765,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(-22.611,-16.684,-29.504,1,1,1,1.0,0, "luce_alta");

  def = create_attribute("standard");

  /*** ATTRIBUTE pupilla ***/
  pupilla = create_attribute("pupilla");
  set_color(pupilla,0.0703,0,0,0.3,0.505);
  set_reflectivity(pupilla,0.330,15);
  /*** ATTRIBUTE bianco ***/
  bianco = create_attribute("bianco");
  set_color(bianco,1,0.8745,0.8196,0.1,1);
  set_reflectivity(bianco,0,2);

  /*******CARICAMENTO SUPERFICI CORNA******/
  corna =read_obj("corno.obj","corna");
  set_domain_texture(corna, def, "texture/corna.hr",0, 1,0,1,0,0.1, 1);
  scene = create_list(corna, "scene");

  /*******CARICAMENTO SUPERFICI TESTA******/
  testa = read_nurbs("testa.dbe");
  set_domain_texture(testa, def, "texture/corna.hr",0, 1,0,1,0,0.1, 1);
  ITEM lista_testa = create_list(testa,"testa");

  pupilla_dx = read_nurbs("pupilla_dx.db");
  pupilla_sx = read_nurbs("pupilla_sx.db");
  set_attribute(pupilla_dx,pupilla);
  set_attribute(pupilla_sx,pupilla);
  lista_testa = insert_in_list(lista_testa,pupilla_sx);
  lista_testa = insert_in_list(lista_testa,pupilla_dx);

  parte_alta = read_nurbs("parte_alta.dbe");
  set_domain_texture(parte_alta, def, "texture/parte_alta.hr",0, 1,0,1,0,0.1, 1);
  lista_testa = insert_in_list(lista_testa,parte_alta);

  orecchio_sx = read_nurbs("orecchio_sx.dbe");
  set_projection_texture(orecchio_sx, def, "texture/orecchio2.hr" ,0, 1, 0.1, 1);
  lista_testa = insert_in_list(lista_testa,orecchio_sx);
  orecchio_dx = read_nurbs("orecchio_dx.dbe");
  set_projection_texture(orecchio_dx, def, "texture/orecchio2.hr" ,0, 1, 0.1, 1);
  lista_testa = insert_in_list(lista_testa,orecchio_dx);
  orecchio_sx_interno = read_nurbs("o_sx_int.db");
  set_attribute(orecchio_sx_interno, bianco);
  lista_testa = insert_in_list(lista_testa,orecchio_sx_interno);
  orecchio_dx_interno = read_nurbs("o_dx_int.db");
  set_attribute(orecchio_dx_interno, bianco);
  lista_testa = insert_in_list(lista_testa,orecchio_dx_interno);

  attacco_corna = read_nurbs("corna.db");
  set_domain_texture(attacco_corna, def, "texture/parte_alta.hr",0, 1,0,1,0,0.0, 1);
  lista_testa = insert_in_list(lista_testa,attacco_corna);

  muso = read_nurbs("muso.dbe");
  set_domain_texture(muso, def, "texture/muso.hr",0, 1,0,1,0,0.1, 1);
  lista_testa = insert_in_list(lista_testa,muso);

  occhio_sx = read_nurbs("occhio_sx.db");
  set_domain_texture(occhio_sx, def, "texture/occhio2.hr",0, 1,0,1,0,0.1, 1);
  lista_testa = insert_in_list(lista_testa,occhio_sx);
  occhio_dx = read_nurbs("occhio_dx.db");
  set_domain_texture(occhio_dx, def, "texture/occhio.hr",0, 1,0,1,0,0.1, 1);
  lista_testa = insert_in_list(lista_testa,occhio_dx);

  scene = insert_in_list(scene,lista_testa);

  /*******CARICAMENTO SUPERFICI CORPO******/
  ITEM corpo, corpo_collo, gamba_avanti_dx,gamba_avanti_sx,gamba_dietro_dx,gamba_dietro_sx;

  corpo = read_nurbs("corpo.db");
  set_domain_texture(corpo, def, "texture/corpo.hr",0, 1,0,1,0,0.1, 1);
  ITEM lista_corpo = create_list(corpo,"corpo");

  corpo_collo = read_nurbs("corpo_collo.db");
  set_domain_texture(corpo_collo, def, "texture/collo2.hr",0, 1,0,1,0,0.1, 1);
  lista_corpo = insert_in_list(lista_corpo,corpo_collo);

  gamba_avanti_dx = read_nurbs("gamba_avanti_dx.db");
  set_domain_texture(gamba_avanti_dx, def, "texture/gamba_avanti.hr",0, 1,0,1,0,0.1, 1);
  lista_corpo = insert_in_list(lista_corpo,gamba_avanti_dx);
  gamba_avanti_sx = read_nurbs("gamba_avanti_sx.db");
  set_domain_texture(gamba_avanti_sx, def, "texture/gamba_avanti_dx.hr",0, 1,0,1,0,0.1, 1);
  lista_corpo = insert_in_list(lista_corpo,gamba_avanti_sx);
  gamba_dietro_dx = read_nurbs("gamba_dietro_dx.db");
  set_domain_texture(gamba_dietro_dx, def, "texture/gamba.hr",0, 1,0,1,0,0.1, 1);
  lista_corpo = insert_in_list(lista_corpo,gamba_dietro_dx);
  gamba_dietro_sx = read_nurbs("gamba_dietro_sx.db");
  set_domain_texture(gamba_dietro_sx, def, "texture/gamba_sx.hr",0, 1,0,1,0,0.1, 1);
  lista_corpo = insert_in_list(lista_corpo,gamba_dietro_sx);

  scene = insert_in_list(scene,lista_corpo);

  ITEM base;
  base = read_nurbs("base2.db");
  set_domain_texture(base, def, "texture/erba.hr",0, 0.1,0,0.1,1,0.1, 1);
  set_scale(base,3,3,3);
  set_translate(base,-36.89,-17,-50);
  scene = insert_in_list(scene,base);


  save_scene("cerbiatto.md","scene_cerbiatto",scene);
  return(0);
}
